## bcachefs-tools 24

=== Makefile ===
PREFIX?=/usr/local
PKG_CONFIG?=pkg-config
INSTALL=install

ifeq ("$(origin V)", "command line")
  BUILD_VERBOSE = $(V)
endif
ifndef BUILD_VERBOSE
  BUILD_VERBOSE = 0
endif

ifeq ($(BUILD_VERBOSE),1)
  Q =
else
  Q = @
endif

CFLAGS+=-std=gnu11 -O2 -g -MMD -Wall -fPIC 			\
	-Wno-pointer-sign					\
	-fno-strict-aliasing					\
	-fno-delete-null-pointer-checks				\
	-I. -Iinclude -Iraid					\
	-D_FILE_OFFSET_BITS=64					\
	-D_GNU_SOURCE						\
	-D_LGPL_SOURCE						\
	-DRCU_MEMBARRIER					\
	-DZSTD_STATIC_LINKING_ONLY				\
	-DFUSE_USE_VERSION=32					\
	-DNO_BCACHEFS_CHARDEV					\
	-DNO_BCACHEFS_FS					\
	-DNO_BCACHEFS_SYSFS					\
	-DVERSION_STRING='"$(VERSION)"'				\
	$(EXTRA_CFLAGS)
LDFLAGS+=$(CFLAGS) $(EXTRA_LDFLAGS)

## Configure Tools
PYTEST_ARGS?=
PYTEST_CMD?=$(shell \
	command -v pytest-3 \
	|| which pytest-3 2>/dev/null \
)
PYTEST:=$(PYTEST_CMD) $(PYTEST_ARGS)

CARGO_ARGS=
CARGO=cargo $(CARGO_ARGS)
CARGO_PROFILE=release
# CARGO_PROFILE=debug

CARGO_BUILD_ARGS=--$(CARGO_PROFILE)
CARGO_BUILD=$(CARGO) build $(CARGO_BUILD_ARGS)
VERSION?=$(shell git describe --dirty=+ 2>/dev/null || echo v0.1-nogit)

include Makefile.compiler

CFLAGS+=$(call cc-disable-warning, unused-but-set-variable)
CFLAGS+=$(call cc-disable-warning, stringop-overflow)
CFLAGS+=$(call cc-disable-warning, zero-length-bounds)
CFLAGS+=$(call cc-disable-warning, missing-braces)
CFLAGS+=$(call cc-disable-warning, zero-length-array)
CFLAGS+=$(call cc-disable-warning, shift-overflow)
CFLAGS+=$(call cc-disable-warning, enum-conversion)

PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev libkeyutils"
ifdef BCACHEFS_FUSE
	PKGCONFIG_LIBS+="fuse3 >= 3.7"
	CFLAGS+=-DBCACHEFS_FUSE
endif

PKGCONFIG_CFLAGS:=$(shell $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_CFLAGS))
    $(error pkg-config error, command: $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
endif
PKGCONFIG_LDLIBS:=$(shell $(PKG_CONFIG) --libs   $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_LDLIBS))
    $(error pkg-config error, command: $(PKG_CONFIG) --libs $(PKGCONFIG_LIBS))
endif

CFLAGS+=$(PKGCONFIG_CFLAGS)
LDLIBS+=$(PKGCONFIG_LDLIBS)
LDLIBS+=-lm -lpthread -lrt -lkeyutils -laio -ldl
LDLIBS+=$(EXTRA_LDLIBS)

ifeq ($(PREFIX),/usr)
	ROOT_SBINDIR=/sbin
	INITRAMFS_DIR=$(PREFIX)/share/initramfs-tools
else
	ROOT_SBINDIR=$(PREFIX)/sbin
	INITRAMFS_DIR=/etc/initramfs-tools
endif

.PHONY: all
all: bcachefs lib

.PHONY: lib
lib: libbcachefs.so

.PHONY: tests
tests: tests/test_helper

.PHONY: check
check: tests bcachefs
ifneq (,$(PYTEST_CMD))
	$(PYTEST)
else
	@echo "WARNING: pytest not found or specified, tests could not be run."
endif

.PHONY: TAGS tags
TAGS:
	ctags -e -R .

tags:
	ctags -R .

SRCS=$(shell find . -type f ! -path '*/.*/*' -iname '*.c')
DEPS=$(SRCS:.c=.d)
-include $(DEPS)

OBJS=$(SRCS:.c=.o)

%.o: %.c
	@echo "    [CC]     $@"
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

bcachefs: $(filter-out ./tests/%.o, $(OBJS))
	@echo "    [LD]     $@"
	$(Q)$(CC) $(LDFLAGS) $+ $(LOADLIBES) $(LDLIBS) -o $@

RUST_SRCS=$(shell find rust-src/ -type f -iname '*.rs')
MOUNT_SRCS=$(filter %mount, $(RUST_SRCS))

debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
debug: bcachefs

MOUNT_OBJ=$(filter-out ./bcachefs.o ./tests/%.o ./cmd_%.o , $(OBJS))
libbcachefs.so: LDFLAGS+=-shared
libbcachefs.so: $(MOUNT_OBJ)
	@echo "    [CC]     $@"
	$(Q)$(CC) $(LDFLAGS) $+ -o $@ $(LDLIBS)

MOUNT_TOML=rust-src/mount/Cargo.toml
mount.bcachefs: lib $(MOUNT_SRCS)
	LIBBCACHEFS_LIB=$(CURDIR) \
	LIBBCACHEFS_INCLUDE=$(CURDIR) \
	$(CARGO_BUILD) --manifest-path $(MOUNT_TOML)

	ln -f rust-src/mount/target/$(CARGO_PROFILE)/bcachefs-mount $@


tests/test_helper: $(filter ./tests/%.o, $(OBJS))
	@echo "    [LD]     $@"
	$(Q)$(CC) $(LDFLAGS) $+ $(LOADLIBES) $(LDLIBS) -o $@

# If the version string differs from the last build, update the last version
ifneq ($(VERSION),$(shell cat .version 2>/dev/null))
.PHONY: .version
endif
.version:
	@echo "  [VERS]    $@"
	$(Q)echo '$(VERSION)' > $@

# Rebuild the 'version' command any time the version string changes
cmd_version.o : .version

.PHONY: install
install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
install: bcachefs lib
	$(INSTALL) -m0755 -D bcachefs      -t $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0755    fsck.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0755    mkfs.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0644 -D bcachefs.8    -t $(DESTDIR)$(PREFIX)/share/man/man8/
	$(INSTALL) -m0755 -D initramfs/script $(DESTDIR)$(INITRAMFS_SCRIPT)
	$(INSTALL) -m0755 -D initramfs/hook   $(DESTDIR)$(INITRAMFS_HOOK)
	$(INSTALL) -m0755 -D mount.bcachefs.sh $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0755 -D libbcachefs.so -t $(DESTDIR)$(PREFIX)/lib/

	sed -i '/^# Note: make install replaces/,$$d' $(DESTDIR)$(INITRAMFS_HOOK)
	echo "copy_exec $(ROOT_SBINDIR)/bcachefs /sbin/bcachefs" >> $(DESTDIR)$(INITRAMFS_HOOK)

.PHONY: clean
clean:
	@echo "Cleaning all"
	$(Q)$(RM) bcachefs mount.bcachefs libbcachefs_mount.a tests/test_helper .version *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
	$(Q)$(RM) -rf rust-src/*/target

.PHONY: deb
deb: all
	debuild -us -uc -nc -b -i -I

bcachefs-principles-of-operation.pdf: doc/bcachefs-principles-of-operation.tex
	pdflatex doc/bcachefs-principles-of-operation.tex
	pdflatex doc/bcachefs-principles-of-operation.tex

doc: bcachefs-principles-of-operation.pdf

.PHONY: update-bcachefs-sources
update-bcachefs-sources:
	git rm -rf --ignore-unmatch libbcachefs
	test -d libbcachefs || mkdir libbcachefs
	cp $(LINUX_DIR)/fs/bcachefs/*.[ch] libbcachefs/
	git add libbcachefs/*.[ch]
	cp $(LINUX_DIR)/include/trace/events/bcachefs.h include/trace/events/
	git add include/trace/events/bcachefs.h
	cp $(LINUX_DIR)/include/linux/xxhash.h include/linux/
	git add include/linux/xxhash.h
	cp $(LINUX_DIR)/lib/xxhash.c linux/
	git add linux/xxhash.c
	cp $(LINUX_DIR)/kernel/locking/six.c linux/
	git add linux/six.c
	cp $(LINUX_DIR)/include/linux/six.h include/linux/
	git add include/linux/six.h
	cp $(LINUX_DIR)/include/linux/list_nulls.h include/linux/
	git add include/linux/list_nulls.h
	cp $(LINUX_DIR)/include/linux/poison.h include/linux/
	git add include/linux/poison.h
	cp $(LINUX_DIR)/include/linux/generic-radix-tree.h include/linux/
	git add include/linux/generic-radix-tree.h
	cp $(LINUX_DIR)/lib/generic-radix-tree.c linux/
	git add linux/generic-radix-tree.c
	cp $(LINUX_DIR)/include/linux/kmemleak.h include/linux/
	git add include/linux/kmemleak.h
	cp $(LINUX_DIR)/include/linux/printbuf.h include/linux/
	git add include/linux/printbuf.h
	cp $(LINUX_DIR)/lib/printbuf.c linux/
	git add linux/printbuf.c
	cp $(LINUX_DIR)/lib/math/mean_and_variance.c linux/
	git add linux/mean_and_variance.c
	cp $(LINUX_DIR)/include/linux/mean_and_variance.h include/linux/
	git add include/linux/mean_and_variance.h
	cp $(LINUX_DIR)/lib/math/int_sqrt.c linux/
	git add linux/int_sqrt.c
	cp $(LINUX_DIR)/scripts/Makefile.compiler ./
	git add Makefile.compiler
	$(RM) libbcachefs/*.mod.c
	git -C $(LINUX_DIR) rev-parse HEAD | tee .bcachefs_revision
	git add .bcachefs_revision


.PHONY: update-commit-bcachefs-sources
update-commit-bcachefs-sources: update-bcachefs-sources
	git commit -m "Update bcachefs sources to $(shell git -C $(LINUX_DIR) show --oneline --no-patch)"

SRCTARXZ = bcachefs-tools-$(VERSION).tar.xz
SRCDIR=bcachefs-tools-$(VERSION)

.PHONY: tarball
tarball: $(SRCTARXZ)

$(SRCTARXZ) : .gitcensus
	$(Q)tar --transform "s,^,$(SRCDIR)/," -Jcf $(SRCDIR).tar.xz  \
	    `cat .gitcensus` 
	@echo Wrote: $@

.PHONY: .gitcensus
.gitcensus:
	$(Q)if test -d .git; then \
	  git ls-files > .gitcensus; \
	fi

=== debian/control ===
Source: bcachefs-tools
Maintainer: Jonathan Carter <jcc@debian.org>
Section: utils
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               python3-docutils,
               python3-pytest,
               libaio-dev,
               libfuse3-dev,
               libblkid-dev,
               libkeyutils-dev,
               liblz4-dev,
               libscrypt-dev,
               libsodium-dev,
               libudev-dev,
               liburcu-dev,
               libzstd-dev,
               uuid-dev,
               zlib1g-dev
Homepage: https://bcachefs.org/
Vcs-Git: https://salsa.debian.org/jcc/bcachefs-tools.git
Vcs-Browser: https://salsa.debian.org/jcc/bcachefs-tools

Package: bcachefs-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: initramfs-tools | linux-initramfs-tool
Description: bcachefs userspace tools
 Userspace tools for bcachefs, a modern copy on write, checksumming, multi
 device filesystem.
 .
 Note: The current Debian kernels do not come with bcachefs support, you
 will have to use your own kernel or one provided by a 3rd party that
 contains bcachefs support.

## bcachefs-tools 24+really1.3.4

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
+VERSION=1.3.3
+
 PREFIX?=/usr/local
 PKG_CONFIG?=pkg-config
 INSTALL=install
+LN=ln
 
 ifeq ("$(origin V)", "command line")
   BUILD_VERBOSE = $(V)
@@ -17,6 +20,7 @@
 
 CFLAGS+=-std=gnu11 -O2 -g -MMD -Wall -fPIC 			\
 	-Wno-pointer-sign					\
+	-Wno-deprecated-declarations				\
 	-fno-strict-aliasing					\
 	-fno-delete-null-pointer-checks				\
 	-I. -Iinclude -Iraid					\
@@ -33,22 +37,17 @@
 	$(EXTRA_CFLAGS)
 LDFLAGS+=$(CFLAGS) $(EXTRA_LDFLAGS)
 
-## Configure Tools
-PYTEST_ARGS?=
-PYTEST_CMD?=$(shell \
-	command -v pytest-3 \
-	|| which pytest-3 2>/dev/null \
-)
-PYTEST:=$(PYTEST_CMD) $(PYTEST_ARGS)
-
-CARGO_ARGS=
+ifdef CARGO_TOOLCHAIN_VERSION
+  CARGO_TOOLCHAIN = +$(CARGO_TOOLCHAIN_VERSION)
+endif
+
+CARGO_ARGS=${CARGO_TOOLCHAIN}
 CARGO=cargo $(CARGO_ARGS)
 CARGO_PROFILE=release
 # CARGO_PROFILE=debug
 
 CARGO_BUILD_ARGS=--$(CARGO_PROFILE)
 CARGO_BUILD=$(CARGO) build $(CARGO_BUILD_ARGS)
-VERSION?=$(shell git describe --dirty=+ 2>/dev/null || echo v0.1-nogit)
 
 include Makefile.compiler
 
@@ -81,29 +80,22 @@
 LDLIBS+=$(EXTRA_LDLIBS)
 
 ifeq ($(PREFIX),/usr)
-	ROOT_SBINDIR=/sbin
+	ROOT_SBINDIR?=/sbin
 	INITRAMFS_DIR=$(PREFIX)/share/initramfs-tools
 else
-	ROOT_SBINDIR=$(PREFIX)/sbin
+	ROOT_SBINDIR?=$(PREFIX)/sbin
 	INITRAMFS_DIR=/etc/initramfs-tools
 endif
 
 .PHONY: all
-all: bcachefs lib
-
-.PHONY: lib
-lib: libbcachefs.so
+all: bcachefs
+
+.PHONY: debug
+debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
+debug: bcachefs
 
 .PHONY: tests
 tests: tests/test_helper
-
-.PHONY: check
-check: tests bcachefs
-ifneq (,$(PYTEST_CMD))
-	$(PYTEST)
-else
-	@echo "WARNING: pytest not found or specified, tests could not be run."
-endif
 
 .PHONY: TAGS tags
 TAGS:
@@ -112,7 +104,7 @@
 tags:
 	ctags -R .
 
-SRCS=$(shell find . -type f ! -path '*/.*/*' -iname '*.c')
+SRCS=$(sort $(shell find . -type f ! -path '*/.*/*' -iname '*.c'))
 DEPS=$(SRCS:.c=.d)
 -include $(DEPS)
 
@@ -122,30 +114,25 @@
 	@echo "    [CC]     $@"
 	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<
 
-bcachefs: $(filter-out ./tests/%.o, $(OBJS))
+BCACHEFS_DEPS=libbcachefs.a
+
+ifndef NO_RUST
+	BCACHEFS_DEPS+=rust-src/target/release/libbcachefs_rust.a
+else
+	CFLAGS+=-DBCACHEFS_NO_RUST
+endif
+
+bcachefs: $(BCACHEFS_DEPS)
 	@echo "    [LD]     $@"
-	$(Q)$(CC) $(LDFLAGS) $+ $(LOADLIBES) $(LDLIBS) -o $@
-
-RUST_SRCS=$(shell find rust-src/ -type f -iname '*.rs')
-MOUNT_SRCS=$(filter %mount, $(RUST_SRCS))
-
-debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
-debug: bcachefs
-
-MOUNT_OBJ=$(filter-out ./bcachefs.o ./tests/%.o ./cmd_%.o , $(OBJS))
-libbcachefs.so: LDFLAGS+=-shared
-libbcachefs.so: $(MOUNT_OBJ)
-	@echo "    [CC]     $@"
-	$(Q)$(CC) $(LDFLAGS) $+ -o $@ $(LDLIBS)
-
-MOUNT_TOML=rust-src/mount/Cargo.toml
-mount.bcachefs: lib $(MOUNT_SRCS)
-	LIBBCACHEFS_LIB=$(CURDIR) \
-	LIBBCACHEFS_INCLUDE=$(CURDIR) \
-	$(CARGO_BUILD) --manifest-path $(MOUNT_TOML)
-
-	ln -f rust-src/mount/target/$(CARGO_PROFILE)/bcachefs-mount $@
-
+	$(Q)$(CC) $(LDFLAGS) -Wl,--whole-archive $+ $(LOADLIBES) -Wl,--no-whole-archive $(LDLIBS) -o $@
+
+libbcachefs.a: $(filter-out ./tests/%.o, $(OBJS))
+	@echo "    [AR]     $@"
+	$(Q)ar -rc $@ $+
+
+RUST_SRCS=$(shell find rust-src/src rust-src/bch_bindgen/src -type f -iname '*.rs')
+rust-src/target/release/libbcachefs_rust.a: $(RUST_SRCS)
+	$(CARGO_BUILD) --manifest-path rust-src/Cargo.toml
 
 tests/test_helper: $(filter ./tests/%.o, $(OBJS))
 	@echo "    [LD]     $@"
@@ -165,15 +152,17 @@
 .PHONY: install
 install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
 install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
-install: bcachefs lib
+install: bcachefs
 	$(INSTALL) -m0755 -D bcachefs      -t $(DESTDIR)$(ROOT_SBINDIR)
-	$(INSTALL) -m0755    fsck.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
-	$(INSTALL) -m0755    mkfs.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
 	$(INSTALL) -m0644 -D bcachefs.8    -t $(DESTDIR)$(PREFIX)/share/man/man8/
 	$(INSTALL) -m0755 -D initramfs/script $(DESTDIR)$(INITRAMFS_SCRIPT)
 	$(INSTALL) -m0755 -D initramfs/hook   $(DESTDIR)$(INITRAMFS_HOOK)
-	$(INSTALL) -m0755 -D mount.bcachefs.sh $(DESTDIR)$(ROOT_SBINDIR)
-	$(INSTALL) -m0755 -D libbcachefs.so -t $(DESTDIR)$(PREFIX)/lib/
+	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mkfs.bcachefs
+	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/fsck.bcachefs
+	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mount.bcachefs
+	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mkfs.fuse.bcachefs
+	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/fsck.fuse.bcachefs
+	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mount.fuse.bcachefs
 
 	sed -i '/^# Note: make install replaces/,$$d' $(DESTDIR)$(INITRAMFS_HOOK)
 	echo "copy_exec $(ROOT_SBINDIR)/bcachefs /sbin/bcachefs" >> $(DESTDIR)$(INITRAMFS_HOOK)
@@ -181,18 +170,27 @@
 .PHONY: clean
 clean:
 	@echo "Cleaning all"
-	$(Q)$(RM) bcachefs mount.bcachefs libbcachefs_mount.a tests/test_helper .version *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
+	$(Q)$(RM) bcachefs libbcachefs.a tests/test_helper .version *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
 	$(Q)$(RM) -rf rust-src/*/target
 
 .PHONY: deb
 deb: all
 	debuild -us -uc -nc -b -i -I
 
+.PHONY: rpm
+rpm: clean
+	rpmbuild --build-in-place -bb --define "_version $(subst -,_,$(VERSION))" packaging/bcachefs-tools.spec
+
 bcachefs-principles-of-operation.pdf: doc/bcachefs-principles-of-operation.tex
 	pdflatex doc/bcachefs-principles-of-operation.tex
 	pdflatex doc/bcachefs-principles-of-operation.tex
 
 doc: bcachefs-principles-of-operation.pdf
+
+.PHONY: cargo-update-msrv
+cargo-update-msrv:
+	cargo +nightly generate-lockfile --manifest-path rust-src/Cargo.toml -Zmsrv-policy
+	cargo +nightly generate-lockfile --manifest-path rust-src/bch_bindgen/Cargo.toml -Zmsrv-policy
 
 .PHONY: update-bcachefs-sources
 update-bcachefs-sources:
@@ -200,16 +198,14 @@
 	test -d libbcachefs || mkdir libbcachefs
 	cp $(LINUX_DIR)/fs/bcachefs/*.[ch] libbcachefs/
 	git add libbcachefs/*.[ch]
-	cp $(LINUX_DIR)/include/trace/events/bcachefs.h include/trace/events/
-	git add include/trace/events/bcachefs.h
+	cp $(LINUX_DIR)/include/linux/closure.h include/linux/
+	git add include/linux/closure.h
+	cp $(LINUX_DIR)/lib/closure.c linux/
+	git add linux/closure.c
 	cp $(LINUX_DIR)/include/linux/xxhash.h include/linux/
 	git add include/linux/xxhash.h
 	cp $(LINUX_DIR)/lib/xxhash.c linux/
 	git add linux/xxhash.c
-	cp $(LINUX_DIR)/kernel/locking/six.c linux/
-	git add linux/six.c
-	cp $(LINUX_DIR)/include/linux/six.h include/linux/
-	git add include/linux/six.h
 	cp $(LINUX_DIR)/include/linux/list_nulls.h include/linux/
 	git add include/linux/list_nulls.h
 	cp $(LINUX_DIR)/include/linux/poison.h include/linux/
@@ -220,16 +216,12 @@
 	git add linux/generic-radix-tree.c
 	cp $(LINUX_DIR)/include/linux/kmemleak.h include/linux/
 	git add include/linux/kmemleak.h
-	cp $(LINUX_DIR)/include/linux/printbuf.h include/linux/
-	git add include/linux/printbuf.h
-	cp $(LINUX_DIR)/lib/printbuf.c linux/
-	git add linux/printbuf.c
+	cp $(LINUX_DIR)/lib/math/int_sqrt.c linux/
+	git add linux/int_sqrt.c
 	cp $(LINUX_DIR)/lib/math/mean_and_variance.c linux/
 	git add linux/mean_and_variance.c
 	cp $(LINUX_DIR)/include/linux/mean_and_variance.h include/linux/
 	git add include/linux/mean_and_variance.h
-	cp $(LINUX_DIR)/lib/math/int_sqrt.c linux/
-	git add linux/int_sqrt.c
 	cp $(LINUX_DIR)/scripts/Makefile.compiler ./
 	git add Makefile.compiler
 	$(RM) libbcachefs/*.mod.c

=== debian/changelog ===
bcachefs-tools (24+really1.3.4-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:33:12 +1100

bcachefs-tools (24+really1.3.4-2build1) noble; urgency=medium

  * No-change rebuild against libaio1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 09:13:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: bcachefs-tools
-Maintainer: Jonathan Carter <jcc@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jonathan Carter <jcc@debian.org>
 Section: utils
 Priority: optional
 Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
+               cargo,
                pkg-config,
                python3-docutils,
                python3-pytest,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
# Do not build rust code (dependencies currently unmet)
export NO_RUST=-true

PREFIX := /usr
ROOT_SBINDIR := /usr/sbin

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)


ifeq ($(DEB_BUILD_ARCH),amd64)
    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- "PREFIX=$(PREFIX)" "ROOT_SBINDIR=$(ROOT_SBINDIR)"

override_dh_auto_test:

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/bcachefs-tools_$1\.tar\.gz/ \
  https://github.com/koverstreet/bcachefs-tools/tags .*/v?(\d\S+)\.tar\.gz
